from Node import Node
import logging
import Utility
import hashlib

genesisBlock = "I am the first block"

class OverlayNode(Node):
    def __init__(self,id,network,weight):
        Node.__init__(self,id,network,weight)
        self.startNodeLifeCycleGenerator = self.startNodeLifeCycle()
        # adding initial task of bootstraping node.
        self.todoList['0'].append(("nextOn", self.startNodeLifeCycleGenerator,))
        self.commands.update({})

    def processMessage(self,time,payload):
        super(OverlayNode, self).processMessage(time,payload)
        print("from overlay node : "+str(payload))

    def startNodeLifeCycle(self):
        '''THis is monolithic algorand algorithm for a NOde'''
        self.logger.info("Life cycle started")

        while True:
            #increment round number


            # Checking if I am a Block Propser
            previousHash = hashlib.sha256(genesisBlock.encode('utf-8')).hexdigest()
            currentRound = 0
            step = 0
            blockHeight = 0
            seed = ( previousHash,currentRound,blockHeight )
            roleCount = 20
            role = "BLOCK_PROPOSER"
            w = self.weight
            badaW = 100

            hash, proof, j = Utility.sortition(self.sk,seed,roleCount, role, w, self.network.badaW, self.pk)
            print("I am the mighty J =",j)
            if j > 0 :
                min_sha_priority = None
                # min_sub_user_index = None
                # msg_to_broadcast = ( currentRound, hash , min_sub_user_index , min_sha_priority )
                print(w)
                print(range(w))
                for sub_user_index in range(w):
                    input_to_SHA256 = (hash , sub_user_index,)  # TODO : can concatenation means this
                    sha256_hash = hashlib.sha256((str(input_to_SHA256)).encode('utf-8')).hexdigest()
                    print(sha256_hash)
                    if not min_sha_priority :
                        min_sha_priority = sha256_hash
                        min_sub_user_index = sub_user_index
                    if sha256_hash < min_sha_priority:
                        min_sha_priority =  sha256_hash
                        min_sub_user_index = sub_user_index


                msg_to_broadcast = ( currentRound, hash , min_sub_user_index , min_sha_priority )
                print(msg_to_broadcast)
                self.logger.info(msg_to_broadcast)

            print("i am before yield 1",self.id)
            yield "resume"
            print("i am before yield 2", self.id)
            yield

            '''
             TODo check if node is selected as BLOCK_PROPOSER
                if yes 
                then
                    select highest priority subuser and gossip the message
                    wait for lambda_proposer=3 sec and hear other block propositions
                    take decision based on received propositions and determine if himself is a highest priority or not
                    if yes
                        broacast the block proposal <format of block proposal>
                
                everybody except highest priority block proposer waits for  t_proposer+t_block time to here the proposed block
                    if received proposal
                    then 
                        start BA* with this new block
                        validate sortition of proposed block
                        if yes
                        then
                            start reduction
                        else 
                            vote for empty block
                    else 
                        start BA* with empty block
                
                
                        
                        
            '''


            pass

        pass


























































class A(object):
    def __init__(self,id):
        self.id = id
        self.commands = {"sendMessage": self.sendMessage,
                         }

    def sendMessage(self):
        pass

    def process(self,param):
        print("from A " +str(param) )
        param.pop(0)
        param.pop(0)

class B(A):
    def __init__(self,id):
        A.__init__(self, id)
        self.commands.update({"hello":self.working})



    def working(self):
        pass

    def process(self,param):
        super(B, self).process(param)
        print("from B" + str(param))


if __name__ == '__main__':
    l = (1,2,tuple(str('3|4|5').split('|')))
    x = B(2)
    print(x.commands)
    x.process(list(l))
